from flask import render_template, url_for, flash, redirect, request, Blueprint
from flask_login import login_user, current_user, logout_user, login_required
from minibase import db, bcrypt
from minibase.config import themeMinibase, globalVars
from minibase.database.models import User, Post
from minibase.users.forms import (registrationForm, loginForm, updateAccountForm,
                                  requestResetForm, resetPasswordForm)
from minibase.users.utils import save_picture, send_reset_email


# Declaring a blueprint
users = Blueprint('users', __name__)


# Route is the file that is going to be generated
@users.route("/register", methods=['GET', 'POST'])
def register():
    if current_user.is_authenticated:
        return redirect(url_for('main.home'))

    form = registrationForm()
    if form.validate_on_submit():
        hashed_pw = bcrypt.generate_password_hash(form.password.data).decode('utf-8')
        user = User(username=form.username.data, email=form.email.data, password=hashed_pw)
        db.session.add(user)
        db.session.commit()
        flash(f'{"Your account has been created you can now log in!"}', 'success')
        return redirect(url_for('users.login'))

    return render_template('register.html',
                            title='Register',
                            theme=themeMinibase,
                            globalVars=globalVars,
                            form=form)


@users.route("/login", methods=['GET', 'POST'])
def login():
    if current_user.is_authenticated:  # Is the user alredy authenticated?
        return redirect(url_for('main.home'))  # Then redirect home

    form = loginForm()
    if form.validate_on_submit():
        user = User.query.filter_by(email=form.email.data).first()
        if user and bcrypt.check_password_hash(user.password, form.password.data):
            login_user(user, remember=form.remember.data)
            next_page = request.args.get('next')
            return redirect(next_page) if next_page else redirect(url_for('main.home'))
        else:
            flash('Login unsuccessful. Please chek your Email and Password!', 'danger')
    return render_template('login.html',
                            title='Login',
                            theme=themeMinibase,
                            globalVars=globalVars,
                            form=form)

@users.route("/logout")
def logout():
    logout_user()
    return redirect(url_for('main.home'))


@users.route("/account", methods=['GET', 'POST'])
@login_required
def account():
    form = updateAccountForm()
    if form.validate_on_submit():
        if form.picture.data:
            picture_file = save_picture(form.picture.data)
            current_user.image_file = picture_file
        current_user.username = form.username.data
        current_user.email = form.email.data
        db.session.commit()
        flash('Your account has been updated!', 'success')
        return redirect(url_for('users.account'))
    elif request.method == 'GET':
        form.username.data = current_user.username
        form.email.data = current_user.email
    image_file = url_for('static', filename='pics/' + current_user.image_file)
    return render_template('account.html',
                            title='Account',
                            theme=themeMinibase,
                            globalVars=globalVars,
                            image_file=image_file,
                            form=form)


@users.route("/user/<string:username>")
def user_posts(username):
    user = User.query.filter_by(username=username).first_or_404()
    page = request.args.get('page', 1, type=int)
    posts = Post.query.filter_by(author=user)\
            .order_by(Post.date_posted.asc())\
            .paginate(page=page, per_page=2)
    return render_template('user_posts.html',
                            theme=themeMinibase,
                            globalVars=globalVars,
                            posts=posts,
                            user=user)

@users.route("/reset_password", methods=['GET', 'POST'])
def reset_request():
    if current_user.is_authenticated:
        return redirect(url_for('main.home'))
    form = requestResetForm()
    if form.validate_on_submit():
        user = User.query.filter_by(email=form.email.data).first()
        send_reset_email(user)
        flash('An Email has benn sent with instruction to reset your password', 'warning')
    return render_template('reset_request.html',
                            title='Reset Password',
                            theme=themeMinibase,
                            globalVars=globalVars,
                            form=form)


@users.route("/reset_password/<token>", methods=['GET', 'POST'])
def reset_token(token):
    if current_user.is_authenticated:
        return redirect(url_for('main.home'))
    user = User.verify_reset_token(token)
    if user is None:
        flash('That is an invalid or expired token', 'warning')
        return redirect(url_for('users.reset_request'))
    form = resetPasswordForm()
    if form.validate_on_submit():
        hashed_pw = bcrypt.generate_password_hash(form.password.data).decode('utf-8')
        user.password = hashed_pw
        db.session.commit()
        flash(f'{"Your password has benn updated"}', 'success')
        return redirect(url_for('users.login'))
    return render_template('reset_token.html',
                            title='Reset Password',
                            theme=themeMinibase,
                            globalVars=globalVars,
                            form=form)
